<div class="page-header">
  <h3 class="page-title">
    <span class="page-title-icon bg-gradient-primary text-white mr-2">
      <i class="mdi mdi-food-variant"></i>
    </span>
    Pedidos
  </h3>
  <nav aria-label="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a routerLink="/dashboard">Inicio</a></li>
      <li class="breadcrumb-item active" aria-current="page">Pedidos</li>
    </ol>
  </nav>
</div>
<!-- boton  -->
<div class="row d-flex justify-content-between align-items-baseline" style="margin-right:auto; margin-left:auto;">
  <div></div>
  <button type="button" class="btn btn-dark btn-fw" (click)="openModalCreate(ModalContent)">
    <i class="mdi mdi-plus-box"> Crear pedido</i>
  </button>
</div>
<!-- boton -->
<!-- Inicio de table -->
<div class="row">
  <div class="col-md-12 grid-margin stretch-card">
    <div class="card">
      <div class="card-body">
        <div class="d-sm-flex align-items-center mb-4">
          <h4 class="title mb-sm-0">Listado de pedidos</h4>
        </div>
        <div class="table-responsive border rounded p-1">
          <table datatable [dtOptions]="dtOptions" [dtTrigger]="dtTrigger" class="table table-striped">
            <thead>
              <tr>
                <th class="font-weight-bold">Nombre cliente</th>
                <!-- <th class="font-weight-bold">Fecha pedido</th> -->
                <th class="font-weight-bold">Tipo entrega</th>
                <th class="font-weight-bold">Fecha entrega</th>
                <th class="font-weight-bold">Hora entrega</th>
                <th class="font-weight-bold">Entrega</th>
                <th class="font-weight-bold">Estado</th>
                <th class="font-weight-bold">Recibido por</th>
                <th class="font-weight-bold">Acciones</th>
              </tr>
            </thead>
            <tbody>
              <tr *ngFor="let item of itemOrder">
                <td>{{ item.cliente.nombre_completo }}</td>
                <!-- <td>{{ item.fecha_pedido | date:'dd-MM-yyy'}}</td> -->
                <td>{{ item.tipo_entrega }}</td>
                <td>{{ item.fecha_entrega | date:'dd-MM-yyy'}}</td>
                <td>{{ item.hora_entrega}}</td>
                <td>
                  <div class="badge badge-success p-2" *ngIf="item.estado_entrega == 1">Realizada</div>
                  <div class="badge badge-danger p-2" *ngIf="item.estado_entrega == 0">Pendiente</div>
                </td>
                <td>
                  <div class="badge badge-danger p-2" *ngIf="item.estado_pedido_id == 1">Pendiente</div>
                  <div class="badge badge-warning p-2" *ngIf="item.estado_pedido_id == 2">Preparación</div>
                  <div class="badge badge-success p-2" *ngIf="item.estado_pedido_id == 3">Finalizado</div>
                </td>
                <td>{{ item.recibido_por}}</td>
                <td>
                  <button type="button" class="btn btn-danger btn-icon" *ngIf="item.estado_pedido_id == 1"
                    (click)="eliminarOrden(item.id)" placement="bottom" ngbTooltip="Eliminar pedido">
                    <i class="mdi mdi-delete-forever"></i>
                  </button>
                  <button type="button" class="btn btn-inverse-dark btn-icon" *ngIf="item.estado_pedido_id == 1"
                    (click)="openModal(EditContent); setOrder(item)" placement="bottom" ngbTooltip="Editar pedido">
                    <i class="mdi mdi-grease-pencil"></i>
                  </button>
                  <button type="button" class="btn btn-dark btn-icon" *ngIf="item.estado_pedido_id == 1"
                    (click)="pasarPreparacion(item.id, contenidoModalShow)" placement="bottom" ngbTooltip="Pasar a preparación">
                    <i class="mdi mdi-chevron-double-right"></i>
                  </button>
                  <button type="button" class="btn btn-dark btn-icon" *ngIf="item.estado_pedido_id == 2"
                    (click)="finalizarPedido(item.id)" placement="bottom" ngbTooltip="Finalizar pedido">
                    <i class="mdi mdi-basket-unfill"></i>
                  </button>
                  <button type="button" class="btn btn-success btn-icon"
                    *ngIf="item.estado_entrega == 0 && item.estado_pedido_id == 3"
                    (click)="openModalEntregar(entregarPedido); asignarPedido(item)" placement="bottom"
                    ngbTooltip="Entregar pedido">
                    <i class="mdi mdi-check"></i>
                  </button>
                  <button type="button" class="btn btn-danger btn-icon"
                    *ngIf="item.estado_entrega == 1  && item.estado_pedido_id == 3" (click)="cancelarEntrega(item)"
                    placement="bottom" ngbTooltip="Cancelar entrega">
                    <i class="mdi mdi-close"></i>
                  </button>
                  <button type="button" class="btn btn-warning btn-icon"
                    (click)="verPedido(item); openModal2(ModalDetalle)" placement="bottom" ngbTooltip="Ver detalle">
                    <i class="mdi mdi-eye"></i>
                  </button>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
  </div>
</div>
<!-- Fin de table -->

<!-- Modal editar inicio -->
<ng-template class="modal fade" #EditContent let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="orderEdit">
          <h4 class="card-title">Editar pedido</h4>
          <div class="form-group">
            <label for="cliente_id">Cliente</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="cliente_id" formControlName="cliente_id">
                <option selected [value]="null">Seleccione un cliente</option>
                <option *ngFor="let item of clientes" [value]="item.id">{{ item.nombre_completo }}</option>
              </select>
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Fecha de entrega</label>
              <input type="date" class="form-control" id="fecha_entrega" placeholder="Ingrese una fecha" #fecha_entrega
                style="background-color:dark" formControlName="fecha_entrega" min="{{fechaInput | date:'yyyy-MM-dd'}}">
            </div>
          </div>
          <div class="form-group">
            <label for="hora_entrega">Hora de entrega</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="hora_entrega" formControlName="hora_entrega">
                <option [ngValue]='null' selected>Seleccione una hora</option>
                <option [value]="'08:00'">08:00</option>
                <option [value]="'09:00'">09:00</option>
                <option [value]="'10:00'">10:00</option>
                <option [value]="'11:00'">11:00</option>
                <option [value]="'12:00'">12:00</option>
                <option [value]="'13:00'">13:00</option>
                <option [value]="'14:00'">14:00</option>
                <option [value]="'15:00'">15:00</option>
                <option [value]="'16:00'">16:00</option>
                <option [value]="'17:00'">17:00</option>
                <option [value]="'18:00'">18:00</option>
                <option [value]="'19:00'">19:00</option>
                <option [value]="'20:00'">20:00</option>
                <option [value]="'21:00'">21:00</option>
                <option [value]="'22:00'">22:00</option>
              </select>
            </div>
          </div>
          <div class="form-group">
            <label for="tipo_entrega">Tipo de entrega</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="tipo_entrega" #tipo_entrega formControlName="tipo_entrega">
                <option selected>Seleccione el tipo de entrega</option>
                <option [value]="'domicilio'">Domicilio</option>
                <option [value]="'retira'">Retira</option>
              </select>
            </div>
          </div>
          <!-- inicio agregar ingrediente -->
          <div class="card">
            <div class="card-body">
              <ng-container formArrayName="productos">
                <div class="table-responsive pt-3">
                  <table class="table table-bordered">
                    <thead>
                      <tr>
                        <th>Producto</th>
                        <th>Cantidad</th>
                        <th>
                          <i class="mdi mdi-plus-box plus" (click)="addProducto()" placement="bottom"
                            ngbTooltip="Agregar producto"></i>
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <ng-container *ngFor=" let productosFormGroup of productos.controls; let i = index">
                        <tr [formGroupName]="i">
                          <td>
                            <div class="form-group">
                              <div class="input-group">
                                <div class="input-group-prepend">
                                </div>
                                <select class="custom-select" id="id" formControlName="id">
                                  <option [ngValue]="null" selected>Seleccione</option>
                                  <option *ngFor="let item of products" [value]="item.id">{{item.producto.nombre}}
                                    {{ item.nombre }}</option>
                                </select>
                              </div>
                            </div>
                          </td>
                          <td style="vertical-align: initial;">
                            <div class="forms-sample">
                              <div class="form-group">
                                <input type="number" class="form-control" id="exampleInputName2"
                                  placeholder="Ingrese una cantidad" #cantidad style="background-color:dark"
                                  formControlName="cantidad">
                              </div>
                            </div>
                          </td>
                          <td style="vertical-align: initial;">
                            <i class="remove mdi mdi-close" (click)="removeProducto(i)" placement="bottom"
                              ngbTooltip="Eliminar producto"></i>
                          </td>
                        </tr>
                      </ng-container>
                    </tbody>
                  </table>
                  <br>
                </div>
              </ng-container>
            </div>
          </div>
          <!-- final agregar ingrediente -->
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2" (click)="guardarEdit(orderEdit.value, modal)"
        [disabled]="this.orderEdit.invalid">Guardar</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear final -->


<!-- Modal crear inicio -->
<ng-template class="modal fade" #ModalContent let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="orderCreate">
          <h4 class="card-title">Crear pedido</h4>
          <p class="card-description">
            Ingrese los campos requeridos para la creación del pedido
          </p>
          <div class="form-group">
            <label for="cliente_id">Cliente</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="cliente_id" formControlName="cliente_id">
                <option selected [value]="null">Seleccione un cliente</option>
                <option *ngFor="let item of clientes" [value]="item.id">{{ item.nombre_completo }}</option>
              </select>
            </div>
          </div>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Fecha de entrega</label>
              <input type="date" class="form-control" id="fecha_entrega" placeholder="Ingrese una fecha" #fecha_entrega
                style="background-color:dark" formControlName="fecha_entrega" min="{{fechaInput | date:'yyyy-MM-dd'}}"
                [value]="fechaValue">
            </div>
          </div>
          <div class="form-group">
            <label for="hora_entrega">Hora de entrega</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="hora_entrega" formControlName="hora_entrega">
                <option [ngValue]='null' selected>Seleccione una hora</option>
                <option [value]="'08:00'">08:00</option>
                <option [value]="'09:00'">09:00</option>
                <option [value]="'10:00'">10:00</option>
                <option [value]="'11:00'">11:00</option>
                <option [value]="'12:00'">12:00</option>
                <option [value]="'13:00'">13:00</option>
                <option [value]="'14:00'">14:00</option>
                <option [value]="'15:00'">15:00</option>
                <option [value]="'16:00'">16:00</option>
                <option [value]="'17:00'">17:00</option>
                <option [value]="'18:00'">18:00</option>
                <option [value]="'19:00'">19:00</option>
                <option [value]="'20:00'">20:00</option>
                <option [value]="'21:00'">21:00</option>
                <option [value]="'22:00'">22:00</option>
              </select>
            </div>
          </div>
          <div class="form-group">
            <label for="tipo_entrega">Tipo de entrega</label>
            <div class="input-group mb-3">
              <div class="input-group-prepend">
              </div>
              <select class="custom-select" id="tipo_entrega" #tipo_entrega formControlName="tipo_entrega">
                <option selected [value]="null">Seleccione el tipo de entrega</option>
                <option [value]="'domicilio'">Domicilio</option>
                <option [value]="'retira'">Retira</option>
              </select>
            </div>
          </div>
          <!-- inicio agregar ingrediente -->
          <div class="card">
            <div class="card-body">
              <ng-container formArrayName="productos">
                <div class="table-responsive pt-3">
                  <table class="table table-bordered">
                    <thead>
                      <tr>
                        <th>Producto</th>
                        <th>Cantidad</th>
                        <th>
                          <i class="mdi mdi-plus-box plus" (click)="addProducto()" placement="bottom"
                            ngbTooltip="Agregar producto"></i>
                        </th>
                      </tr>
                    </thead>
                    <tbody>
                      <ng-container *ngFor=" let productosFormGroup of productos.controls; let i = index">
                        <tr [formGroupName]="i">
                          <td>
                            <div class="form-group">
                              <div class="input-group">
                                <div class="input-group-prepend">
                                </div>
                                <select class="custom-select" id="id" formControlName="id">
                                  <option [ngValue]="null" selected>Seleccione</option>
                                  <option *ngFor="let item of products" [value]="item.id">{{item.producto.nombre}}
                                    {{ item.nombre }}</option>
                                </select>
                              </div>
                            </div>
                          </td>
                          <td style="vertical-align: initial;">
                            <div class="forms-sample">
                              <div class="form-group">
                                <input type="number" class="form-control" id="exampleInputName2"
                                  placeholder="Ingrese una cantidad" #cantidad style="background-color:dark"
                                  formControlName="cantidad">
                              </div>
                            </div>
                          </td>
                          <td style="vertical-align: initial;">
                            <i class="remove mdi mdi-close" (click)="removeProducto(i)" placement="bottom"
                              ngbTooltip="Eliminar producto"></i>
                          </td>
                        </tr>
                      </ng-container>
                    </tbody>
                  </table>
                  <br>
                </div>
              </ng-container>
            </div>
          </div>
          <!-- final agregar ingrediente -->
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2" (click)="crearOrder(orderCreate.value, modal)"
        [disabled]="this.orderCreate.invalid">Crear</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal editar final -->



<!-- Modal ver detalle inicio -->
<ng-template class="modal fade" #ModalDetalle let-modal>
  <div class="modal-content" style="background-color: white;">
    <div class="modal-header" style="border-bottom: 0;">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="row">
        <div class="col-md-12 grid-margin stretch-card">

          <div class="card-body">
            <div class="d-sm-flex align-items-center mb-4">
              <h4 class="card-title mb-sm-0">Detalle de pedido: </h4>
            </div>
            <div class="table-responsive border rounded p-1">
              <table class="table table-striped responsive" style="background-color: white;">
                <thead>
                  <tr>
                    <th class="font-weight-bold">Producto</th>
                    <th class="font-weight-bold">Formato</th>
                    <th class="font-weight-bold">Unidades</th>
                    <th class="font-weight-bold">Valor</th>
                  </tr>
                </thead>
                <tbody>
                  <tr *ngFor="let item of detalleOrden">
                    <td>{{ item.producto.nombre }}</td>
                    <td>{{ item.nombre }}</td>
                    <td>{{ item.formato_has_pedido.unidades}}</td>
                    <td>{{ item.valor}}</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div style="padding-top: 2%;">
              <h6> <b>Para:</b> {{datosCliente.cliente.nombre_completo}}</h6>
              <h6> <b>Fecha de entrega:</b> {{datosCliente.fecha_entrega | date:'dd-MM-yyy'}}</h6>
              <h6> <b>Dirección:</b> <a href="https://www.google.com/maps/place/{{datosCliente.cliente.direccion}}">
                  {{datosCliente.cliente.direccion}}
                </a>
              </h6>
              <h6> <b>Teléfono:</b> {{datosCliente.cliente.telefono}}</h6>
            </div>
          </div>

        </div>
      </div>
    </div>
    <div class="modal-footer" style="border-top: 0;">
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cerrar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->

<!-- Modal crear rol inicio -->
<ng-template class="modal fade" #entregarPedido let-modal>
  <div class="modal-content">
    <div class="modal-header">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="col-12 stretch-card">
        <div class="card-body" [formGroup]="editarEstadoPedido">
          <h4 class="card-title">Entrega de pedido</h4>
          <p class="card-description">
            Ingrese el nombre de la persona que recibe el pedido
          </p>
          <div class="forms-sample">
            <div class="form-group">
              <label for="exampleInputName2">Nombre</label>
              <input type="text" class="form-control" id="recibido_por" placeholder="Ingrese un nombre" #recibido_por
                style="background-color:dark" formControlName="recibido_por">
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <button type="submit" class="btn btn-primary mr-2" (click)="entregarOrder(editarEstadoPedido.value, modal)"
        [disabled]="this.editarEstadoPedido.invalid">Entregar</button>
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cancelar</button>
    </div>
  </div>
</ng-template>

<!-- Modal crear rol final -->


<!-- Modal ver detalle inicio -->
<ng-template class="modal fade" #contenidoModalShow let-modal>
  <div class="modal-content" style="background-color: white;">
    <div class="modal-header" style="border-bottom: 0;">
      <button type="button" class="close" data-bs-dismiss="modal" aria-label="Close" (click)="modal.dismiss()">
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body">
      <div class="row">
        <div class="col-md-12 grid-margin stretch-card">

          <div class="card-body">
            <div class="d-sm-flex align-items-center mb-4">
              <h4 class="card-title mb-sm-0">{{faltantes.message}} </h4>
            </div>
            <div class="table-responsive border rounded p-1" *ngFor="let item of faltantes.data">
                {{item.nombre}} {{item.marca}}
            </div>
            <div class="d-sm-flex align-items-center mb-4">
            <br>
            <br>
            <br>
              <h4 class=" mb-sm-0">No es posible pasar el pedido a preparación</h4>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer" style="border-top: 0;">
      <button type="button" class="btn btn-danger" data-dismiss="modal" (click)="modal.dismiss()">Cerrar</button>
    </div>
  </div>
</ng-template>